from Products.PageTemplates.ZopePageTemplate import ZopePageTemplate as BaseClass

import os, sys
import Globals
from Products.PageTemplates.PageTemplateFile import PageTemplateFile

from urllib import quote

from trml2pdf.trml2pdf import parseString

# ###########################################################################
# Product registration and Add support
manage_addRMLPageTemplateForm = PageTemplateFile('www/cptAdd', globals())
manage_addRMLPageTemplateForm.__name__='manage_addRMLPageTemplateForm'


def manage_addRMLPageTemplate(self, id, title=None, text=None,
                              REQUEST=None, submit=None):
    """Add a RML Page Template with optional file content."""

    id = str(id)
    if REQUEST is None:
        self._setObject(id, RMLPageTemplate(id, text))
        ob = getattr(self, id)
        if title:
            ob.pt_setTitle(title)
        return ob
    else:
        file = REQUEST.form.get('file')
        headers = getattr(file, 'headers', None)
        if headers is None or not file.filename:
            zpt = RMLPageTemplate(id)
        else:
            zpt = RMLPageTemplate(id, file, headers.get('content_type'))

        self._setObject(id, zpt)

        try:
            u = self.DestinationURL()
        except AttributeError:
            u = REQUEST['URL1']

        if submit == " Add and Edit ":
            u = "%s/%s" % (u, quote(id))
        REQUEST.RESPONSE.redirect(u+'/manage_main')
    return ''

# make sure that the security declarations in the ZopePageTemplate object are
# being read in here - the view_rml, and view_asPDF are going to need security
# attributes set on them. Plus getPDF
class RMLPageTemplate(BaseClass):
    """Wrapper object that displays rml files has pdf's when viewed"""

    content_type = 'text/xml'

    manage_options = (BaseClass.manage_options[:2] + \
        ({'label':'View RML',
          'action':'view_rml'},) +
        BaseClass.manage_options[2:])

    meta_type = 'RML Page Template'

    _default_content_fn = os.path.join(Globals.package_home(globals()),
                                       'www', 'default.rml')

##     def __init__(self, *args, **kwargs):
##         return RMLPageTemplate.inheritedAttribute('__init__')(self, *args, **kwargs)

    def __call__(self, *args, **kwargs):
        """
        """
        return self.view_asPDF(self.REQUEST, self.REQUEST.RESPONSE)

    def view_rml(self, *args, **kwargs):
        """
        """
        return RMLPageTemplate.inheritedAttribute('__call__')(self, *args, **kwargs)

    def getPDF(self, REQUEST, RESPONSE = None, *args, **kwargs):
        """
        render the rml code to pdf - but don't set any HTTP headers in the
        process.
        """
        data = RMLPageTemplate.inheritedAttribute('__call__')(self, *args, **kwargs)
        data = parseString(data)

        return data

    def view_asPDF(self, REQUEST, RESPONSE = None, *args, **kwargs):
        """
        call getPDF and set the headers so the returned data can be seen.
        """
        data = self.getPDF(REQUEST, RESPONSE, *args, **kwargs)

        if RESPONSE is not None:
            RESPONSE.setHeader("Content-type", "application/pdf")
            RESPONSE.setHeader("Content-disposition", "inline; filename=%s.pdf" %(self.title_or_id()))
            RESPONSE.setHeader("Content-Length", len(data))

        return data

Globals.InitializeClass(RMLPageTemplate)
